package murach.db;

import java.sql.Connection;
import java.sql.PreparedStatement; // SEE BELOW
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import murach.business.Product;

/**
 * This class maps the Product object (and its fields to the corresponding 
 * fields of the Product table of the mma database
 * 
 * @author pmize@email.uscb.edu
 * @version ICE for 23 Jan 2017
 */
public class ProductDB {
    
    /**
     * Returns a List object that contains all of the Product objects
     * that are stored in the Product table of the mma database
     * 
     * @return list of Product objects
     * @throws DBException 
     */
    public static List<Product> getAll() throws DBException {        
        /* 
        1) create a String that contains a SQL statement that selects
        all columns from the Product table and sorts them in ascending order
        by the ProductID column
        */
        String sql = "SELECT * FROM Product ORDER BY ProductID";
        
        /*
        2) create an ArrayList object that can store Product objects 
        */
        List<Product> products = new ArrayList<>();
        
        /*
        3) connect to the database
        */
        Connection connection = DBUtil.getConnection();
        
        /*
        4) use a "try-with-resources" statement (which will close the objects
        when the try block ends) to create the PreparedStatement and ResultSet
        objects (result of running a query on the database) needed by the getAll()
        method
        */
        try (PreparedStatement ps = connection.prepareStatement(sql);
             ResultSet rs = ps.executeQuery()) {
            
            /* 
            Once the ResultSet object has been created, the getAll() method 
            uses a while loop to read each row in the result set that is 
            generated by executing the query on the MySQL server
            */
            while (rs.next()) /* moves DB cursor to the next row, if there is one */
            {
                int productID = rs.getInt("ProductID");
                String code = rs.getString("Code");
                String description  = rs.getString("Description");
                double price = rs.getDouble("ListPrice");
                
                Product p = new Product();
                p.setId(productID);
                p.setCode(code);
                p.setDescription(description);
                p.setPrice(price);
                products.add(p);
            }
            return products;
        } catch (SQLException e) {
            throw new DBException(e);
        }
    }

    /* 
    More on Prepared Statements:
    ----------------------------
    Each time a Java application sends a new SQL statement to the database
    server, the server checks the statement for syntax errors, prepares an
    "execution plan" for executing the statement, and then executes the statement. 
    
    Note that the String query below has a question mark character (?) in place
    of an actual product code; this is because we want our SQL query to work for 
    ANY product code that the user specifies.
    
    Because this query could be executed several times against the database, 
    the repetition of syntax checking and "execution planning" COULD SLOW THE 
    APPLICATION PERFORMANCE.
    
    A prepared statement will check a single "generic" version of the SQL 
    statement (and prepare an execution plan) only once; from there on out,
    we can simply accept the parameter value (corresponding to the queston 
    mark placeholder in query String) and then execute the statement repeatedly
    without subsequent syntax checking. The resulting performance 
    improvement is one major benefit of using prepared statements.
    
    However, we also want to protect against SQL injection attacks that could 
    result from users entering potentially damaging SQL queries instead of the 
    expected input parameter(s). 
    
    A prepared statement will automatically provide a LAYER OF SECURITY.
    will automatically check parameter values to prevent most types of SQL 
    injection attacks. 
    */
    public static Product get(String productCode) throws DBException {
        String sql = "SELECT * FROM Product WHERE Code = ?";
        Connection connection = DBUtil.getConnection();
        try (PreparedStatement ps = connection.prepareStatement(sql)) { // RUNS ONCE BECAUSE OF CLASS TYPE
            ps.setString(1, productCode);
            ResultSet rs = ps.executeQuery();
            if (rs.next()) {
                long productId = rs.getLong("ProductID");
                String description = rs.getString("Description");
                double price = rs.getDouble("ListPrice");
                rs.close();
                
                Product p = new Product();
                p.setId(productId);
                p.setCode(productCode);
                p.setDescription(description);
                p.setPrice(price);
                
                return p;
            } else {
                rs.close();
                return null;
            }
        } catch (SQLException e) {
            throw new DBException(e);
        }
    }

    public static void add(Product product) throws DBException {
        String sql
                = "INSERT INTO Product (Code, Description, ListPrice) "
                + "VALUES (?, ?, ?)";
        Connection connection = DBUtil.getConnection();
        try (PreparedStatement ps = connection.prepareStatement(sql)) {
            ps.setString(1, product.getCode());
            ps.setString(2, product.getDescription());
            ps.setDouble(3, product.getPrice());
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new DBException(e);
        }
    }

    public static void update(Product product) throws DBException {
        String sql = "UPDATE Product SET "
                + "Code = ?, "
                + "Description = ?, "
                + "ListPrice = ? "
                + "WHERE ProductID = ?";
        Connection connection = DBUtil.getConnection();
        try (PreparedStatement ps = connection.prepareStatement(sql)) {
            ps.setString(1, product.getCode());
            ps.setString(2, product.getDescription());
            ps.setDouble(3, product.getPrice());
            ps.setLong(4, product.getId());
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new DBException(e);
        }        
    }
    
    public static void delete(Product product) 
            throws DBException {
        String sql = "DELETE FROM Product "
                   + "WHERE ProductID = ?";
        Connection connection = DBUtil.getConnection();
        try (PreparedStatement ps = connection.prepareStatement(sql)) {
            ps.setLong(1, product.getId());
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new DBException(e);
        }
    }
}